
"""PrimerIspita2.ipynb


1. Resiti sledece zadatke:

a) Napisati funkciju koja u datoteke koja se prosledjuje kao parametar funkcije, upisuje niz parova oblik (slovo:niska, vrednost:ceo broj) u datoteku sa nazivom koji je prosledjen. Niz je takodje parametar funkcije. Parove napisati u posebnom redu i svaka linija se mora napisati u obliku: _slovo ... broj_
"""

"""
[('a', 9), ('c', 10)...]

ime.txt
a...9
c...10
..
"""
def f1(ime_datoteke, niz):
  with open(ime_datoteke, "w") as fajl:
    for element in niz:
      #fajl.write(element[0]+'...'+str(element[1])+'\n')
      #fajl.write("{0}...{1}\n".format(element[0], element[1]))
      fajl.write(f"{element[0]}...{element[1]}\n")

f1('fajl.txt', [('a', 9), ('c', 10), ('g', 12)])

"""b) Napisati funkciju koja kao parametar prihvata listu realnih brojeva i koja  vraca sledecu sumu:
$S = \sum_{i=0}^{\frac{n}{2}-1}x_{2i} + \prod_{i=0}^{\frac{n}{2}-1}x_{2i+1}$
"""

def f2(lista):
  suma = 0
  for i in range(len(lista)):
    if i%2==0:
      suma += lista[i]

  proizvod = 1
  for i in range(len(lista)):
    if i%2==1:
      proizvod*=lista[i]
  return suma + proizvod

f2([1, 2, 3, 4, 5, 6])

"""c) Napisati funkciju koja iz matrice $n\times m$ izvlaci elemente iz sporedne dijagonale i sortira ih u opadajucem poretku."""

def f3(matrica, n, m):
  """
  i j--------------------
  |  (0,0) (0, 1) (0, 2) (0,3)
  |  (1,0) (1, 1) (1, 2) (1,3)
  |  (2,0) (2, 1) (2, 2) (2,3)
  |  (3,0) (3, 1) (3, 2) (3,3)

  i+j == min(n-1, m-1)
  """
  dijagonala = []
  for i in range(n):
    for j in range(m):
      if i+j == min(n-1, m-1):
        dijagonala.append(matrica[i][j])
  return sorted(dijagonala, reverse=True)

matrica = [
    [1, 2],
    [4, 5],
    [7, 8]
]
f3(matrica, 3 ,2)

"""d) Napisati funkciju koja ucitava brojeve sa standardnog ulaza dok se ne unese stop. Na standarni izlaz ispisati zbir zbira brojeva na parnim mestima i proizvoda brojeva na neparnim mestima."""

def f4():
  lista = []
  while True:
    broj = input() #int(input()) -> izbacuje gresku ukoliko niska ne sadrzi samo brojeve
    if broj=='stop':
      break
    broj = int(broj)
    lista.append(broj)
  print(f2(lista))

f4()

"""2. Napisati sledece klase:

a)Napisati klasu Voce koje sadrzi sledece atribute:
  1. tip - niska
  2. naziv - niska
  3. latinski - niska
  4. godinaProizvodnje - ceo broj

i metode:
  1. konstruktor - postavlja sve parametre na prosledjene. Podrazumevana vrednost atributa _latinski_ je 'NA'
  2. _ _ str _ _() - vraca nisku oblika 'tip -> naziv (latinksi)'
  3. _ _ lt _ _(drugoVoce) - koja poredi ovo voce i drugoVoce po latinskom nazivu. (operator <)
  4. _ _ gt _ _(drugoVoce) - koja poredi ovo voce i drugoVoce po latinskom nazivu. (operator >)
  5. _ _ eq _ _(drugoVoce) - koja poredi ovo voce i drugoVoce po latinskom nazivu. (operator ==)
"""

class Voce:
  def __init__(self, tip, naziv, godina, latinski='NA'):
    self.tip = tip
    self.naziv = naziv
    self.latinski = latinski
    self.godinaProizvodnje = godina

  def __str__(self):
    return self.tip + ' -> '+self.naziv+"("+self.latinski+")"

  def __lt__(self, drugoVoce):
    """<"""
    return self.latinski < drugoVoce.latinski

  def __gt__(self, drugoVoce):
    """>"""
    return self.latinski > drugoVoce.latinski

  def __eq__(self, drugoVoce):
    """<"""
    return self.latinski == drugoVoce.latinski

  def __add__(self, drugoVoce):
    return self.godinaProizvodnje + drugoVoce.godinaProizvodnje

v = Voce('jagoda', 'Sumska jagoda', 2018)
print(v)
v1 = Voce('jagoda', 'Sumska jagoda', 2018)
v < v1
v+v1

"""Napisati klasu Jabuka koja nasledjuje klasu Voce i koja je dodatno okarakterisana sledecim atributima:
1. nivo_kiselosti - broj iz skupa [1, 5]

i sledecim metodama:
1. konstruktor-postavlja sve potrebne parametre na prosledjene. Ukoliko je parametar nivo_kiselosti van skupa postaviti vrednost na 3. Tip voca je uvek jabuka.
2. nivoKiselosti() - vraca nisku koja opisuje nivo kiseslosti:
    1. 5 - 'veoma kiselo'
    2. 4 - 'kiselo'
    3. 3 - 'kiselo-slatko'
    4. 2 - 'slatko'
    5. 1 - 'veoma slatko'
"""

class Jabuka(Voce):
  def __init__(self, naziv, godina, latinski, nivo_kiselosti):
    if nivo_kiselosti < 1 or nivo_kiselosti>5:
      nivo_kiselosti=3
    super().__init__('jabuka', naziv, godina, latinski)
    self.nivo_kiselosti = nivo_kiselosti
  def nivoKiselosti(self):
    if self.nivo_kiselosti == 5:
      return 'veoma kiselo'

    if self.nivo_kiselosti == 4:
      return 'kiselo'

    if self.nivo_kiselosti == 3:
      return 'kiselo-slatko'

    if self.nivo_kiselosti == 2:
      return 'slatko'

    if self.nivo_kiselosti == 1:
      return 'veoma slatko'

j= Jabuka('gala', 2024, 'gallus slatkus', 9)
print(j)
print(j.nivoKiselosti())

"""Napisati klasu Kruska koja nasledjuje klasu Voce i koja je dodatno okarakterisana sledecim atributima:
1. zemljaPorekla - niska

i metodama:
1. konstruktor - koji postavlja sve parametre na prosledjene. Tip voca je uvek kruska.

2. oznaka - vraca nisku oblika: 'zemljPorekla - godinaProizvodnje'
"""

class Kruska(Voce):
  def __init__(self, naziv, godina, latinski, zemlja):
    self.zemljaPorekla = zemlja
    super().__init__('kruska', naziv, godina, latinski)
  def oznaka(self):
    return self.zemljaPorekla +"-"+str(self.godinaProizvodnje)

k = Kruska('viljamovka', 2023, 'vilus vilus', 'Srbija')
print(k)
print(k.oznaka())

"""Napisati klasu Korpa koja sadrzi sledece atribute:
1. voce - niz elemenata klase Voce

i metode:
1. konstruktor - postavlja voce na prazan niz.
2. dodajVoce(vocka) - dodaje voce u niz voca.
3. kojeVoce() - na standardni izlazi ispisuje sortirani niz voca koje je u korpi.
"""

class Korpa:
  def __init__(self):
    self.voce = []

  def dodajVoce(self,vocka):
    self.voce.append(vocka)

  def kojeVoce(self):
    return sorted(self.voce)

korpa = Korpa()
korpa.dodajVoce(Jabuka('gala', 2024, 'gallus slatkus', 1))
korpa.dodajVoce(Jabuka('greni Smit', 2024, 'grenus smitus', 5))
korpa.dodajVoce(Kruska('divlja kruska', 2024, 'ajdar krusak', 'Spanija'))
korpa.dodajVoce(Kruska('pitoma kruska', 2024, 'pitomus krusak', 'Spanija'))
vockice = korpa.kojeVoce()
for voce  in vockice:
  print(voce)

"""3. Resiti sledece probleme:"""

!pip install python-constraint
import constraint

"""a) Resiti sistem:
$$
 x + 2y -z = 14 \\
 3x - 8y + 5z = 38 \\
 x > z \\
 x, y, z\in [0, 20]
$$
i ispisati sva resenja.
"""

problem = constraint.Problem()
problem.addVariables('xyz', range(0, 21)) #1 vise
def o1(x, y, z):
  if x + 2*y - z == 14:
    return True
def o2(x, y, z):
  if 3*x -8*y + 5*z == 38:
    return True
def o3(x, z):
  if x > z:
    return True

problem.addConstraint(o1, "xyz") #['x', 'y', 'z']
problem.addConstraint(o2, "xyz")
problem.addConstraint(o3, "xz")

resenja = problem.getSolutions()
print(resenja)

"""b) Odrediti koje sve razlicite vrednosti zadovoljavaju ovaj uslov:
TWO*TWO+EIGHT=TWELVE
"""

problem = constraint.Problem()
problem.addVariables('te', range(1, 10))
problem.addVariables('woighlv', range(0, 10))

def o(t, w, o, e, i, g, h, l, v):
  two = t*100+w*10+o
  eight = e*10000+i*1000+g*100+h*10+t
  twelve = t*100000 + w*10000 +e*1000 + l*100 +v*10+e
  if two*two + eight == twelve:
    return True

problem.addConstraint(o, 'twoeighlv')
problem.addConstraint(constraint.AllDifferentConstraint(), 'twoeighlv')
resenja = problem.getSolutions()
print(resenja)

for r in resenja:
  two = r['t']*100+r['w']*10+r['o']
  eight = r['e']*10000+r['i']*1000+r['g']*100+r['h']*10+r['t']
  twelve = r['t']*100000 + r['w']*10000 +r['e']*1000 + r['l']*100 +r['v']*10+r['e']
  print("two: ", two)
  print('eight: ', eight)
  print("twelve: ", twelve)

"""c)Data je sledeca tabela:

| Torta | Tezina | Dimenzije(cmxcm) | Energetska vrednost | Kolicina | Cena |
|----|-----|----|-----|----|---|
|Svarcvald| 500g | 40x20 | 1200 | 4 | 1200|
|Rokoko| 430g | 30x20 | 990 | 2 | 900|
|Vasina torta| 230g | 25x20 | 890 | 3 | 1400|
|Napoleon| 200g | 10x15 | 1100 | 5 | 600|

Potrebno je kupiti torte za slavlje tako da ukupna energetska vrednost bude izmedju 4500 kcal i 6000 kcal (ukljucujuci i njih), tezine do 3kg i zapremine najmanje $700dm^3$ (smatrati  da je visina torti 2cm). Na standardni izlaz ispisati koliko najmanje para treba potrositi kako bi se ispunili zahtevi.
"""

problem = constraint.Problem()
problem.addVariable('s', range(0, 5)) #za 1 vise
problem.addVariable('r', range(0, 3)) #za 1 vise
problem.addVariable('v', range(0, 4)) #za 1 vise
problem.addVariable('n', range(0, 6)) #za 1 vise

def energetskaVrednost(s, r, v, n):
  zbir = s*1200 + r*990+v*890+n*1100
  if zbir >= 4500 and zbir <= 10000:
    return True

def tezina(s, r, v, n):
  zbir = s*500 + r*430 + v*230 + n*200
  if zbir < 7000:
    return True

#1 cm = 0.1 dm
def zapremina(s, r, v, n):
  zs = 4*2*0.2
  zr = 3*2*0.2
  zv = 2.5*2*0.2
  zn = 1*1.5*0.2

  zapremina = s*zs + r*zr + v*zv + n*zn
  if zapremina >= 10:
    return True

problem.addConstraint(tezina, "srvn")
problem.addConstraint(energetskaVrednost, "srvn")
problem.addConstraint(zapremina, "srvn")
resenja = problem.getSolutions()

min_cena = resenja[0]['s']*1200 + resenja[0]['r']*900 + resenja[0]['v']*1400 + resenja[0]['n']*600

for r in resenja:
  cena = r['s']*1200 + r['r']*900 + r['v']*1400 + r['n']*600
  if cena < min_cena:
    min_cena = cena

print(min_cena)

"""4. Resiti sledece zadatke bez upotrebe petlji

a) Lista celih brojeva se unosi sa standardnog ulaza dok se ne unese rec stop. Svakom broju na parnoj poziciji dodati 5, dok svakom broju na neparnoj poziciji oduzeti 3.
"""

lista = []
while True:
  broj = input()
  if broj=='stop':
    break
  lista.append(int(broj))
lista_poz = [(i, lista[i]) for i in range(len(lista))]
print(lista_poz)

lista_parnih = [(i,lista[i]+5) for i in range(len(lista)) if i%2==0]
lista_neparnih = [(i, lista[i]-3) for i in range(len(lista)) if i%2==1]
print(lista_parnih, lista_neparnih)
lista = sorted(lista_parnih + lista_neparnih, key=lambda x: x[0])
print(lista)
lista = [l[1] for l in lista]

print(lista)

"""b)Napisati funkciju sumaKvadrata(n) koja  racuna sumu kvadrata prvih n prirodnih brojeva bez koriscenja formule"""

def sumaKvadrata(n):
  lista = [i*i for i in range(1, n+1)]
  return sum(lista) #reduce(lambda e, a: e + a, lista)

"""c) U datoteci knjige.json se nalaze podaci o knjigama u knjizari u sledecem formatu:
> [{"oznaka": broj, "naziv_autora": nazivknjge i autora, "kolicina":kolicina, "cena": cena po komadu},...]

Napisati program koji ispisuje listu parova (oznaka, ukupna vrednost). Ukupna vrednost se sra-
čunava na osnovu cene i broja primeraka, a povećava se za 10 dinara ukoliko ukupna cena knjiga
sa istom oznakom ne prelazi minimalnu cenu od 100 dinara.
"""

import json
with open('knjige.json', 'r') as fajl:
  knjige = json.load(fajl)
print(knjige)

lista_parova = [(i, knjige[i]['oznaka'], knjige[i]['cena']*knjige[i]['kolicina']) for i in range(len(knjige))]
print(lista_parova)

knjigeManje = [k for k in lista_parova if k[2]<100]
knjigeVece = [k for k in lista_parova if k[2]>=100]
knjigeManje = [(k[0], k[1], k[2]+10) for k in knjigeManje]
knjige = knjigeManje + knjigeVece
knjige.sort(key=lambda x: x[0])
print(knjige)

knjige = [(k[1], k[2]) for k in knjige]
print(knjige)

